#ifndef NONRECURSIVE_H
#define NONRECURSIVE_H

/*** additional non-recursive versions of certain functions ***/

PyAPI_FUNC(PyObject *) PyEval_CallObjectWithKeywords_nr
	(PyObject *func, PyObject *arg, PyObject *kw);

PyAPI_FUNC(PyObject *) PyEval_CallObject_nr(PyObject *func, PyObject *arg);

PyAPI_FUNC(PyObject *) PyObject_CallObject_nr(PyObject *o, PyObject *a);

PyAPI_FUNC(PyObject *) PyObject_Call_nr(PyObject *func, PyObject *arg, PyObject *kw);

PyAPI_FUNC(PyObject *) PyObject_CallFunction_nr(PyObject *callable, char *format, ...);

PyAPI_FUNC(PyObject *) PyObject_CallMethod_nr(PyObject *o, char *name, char *format, ...);

PyAPI_FUNC(PyObject *) PyCFunction_Call_nr(PyObject *func, PyObject *arg, PyObject *kw);

#define PyCFunction_GET_FUNCTION_NR(func) \
        (((PyCFunctionObject *)func) -> m_meth_nr)

/* helper to initialize method tables with _nr functions */
PyAPI_FUNC(int) slp_adjust_method_table(PyMethodDef *methods);

/* internal function for initialization */
int init_nonrecursive(void);

#endif
