#ifndef STACKLESS_FRAME_H
#define STACKLESS_FRAME_H

PyAPI_DATA(PyTypeObject) PyCFrame_Type;
PyAPI_DATA(PyTypeObject) PyBaseFrame_Type;

#define PyBaseFrame_Check(op) PyObject_TypeCheck(op, &PyBaseFrame_Type)
#define PyBaseFrame_CheckExact(op) ((op)->ob_type == &PyBaseFrame_Type)
#define PyCFrame_Check(op) PyObject_TypeCheck(op, &PyCFrame_Type)
#define PyCFrame_CheckExact(op) ((op)->ob_type == &PyCFrame_Type)

/* support for soft stackless */

typedef PyObject *(PyFrame_ExecFunc) (struct _frame *);

/* these macros go into frame.c */
#define STACKLESS_FRAME_NEW \
	f->f_execute = NULL; \
	f->f_callee = NULL;

#define STACKLESS_FRAME_MEMBERS \
	{"execute", T_INT, offsetof(PyFrameObject, f_execute), READONLY},

#define STACKLESS_FRAME_DEALLOC \
    Py_XDECREF(f->f_callee);

#define STACKLESS_FRAME_CLEAR \
	STACKLESS_FRAME_DEALLOC; \
    f->f_callee = NULL;

#endif
